Index: /pjproject/branches/projects/uwp/build/vs/pjproject-vs14-build-targets.targets
===================================================================
--- /pjproject/branches/projects/uwp/build/vs/pjproject-vs14-build-targets.targets	(revision 5528)
+++ /pjproject/branches/projects/uwp/build/vs/pjproject-vs14-build-targets.targets	(revision 5528)
@@ -0,0 +1,9 @@
+<!--This will define targets to override the default ones useful to skipped the target of specific project-->
+<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Target Name="Build">
+    <Message Text="Skipped project build"></Message>
+  </Target>  
+  <Target Name="Clean">
+    <Message Text="Skipped project clean"></Message>
+  </Target>   
+</Project>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj	(revision 5527)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj	(revision 5528)
@@ -110,7 +110,5 @@
   <ImportGroup Label="ExtensionSettings">
   </ImportGroup>
-  <ImportGroup Condition="'$(API_Family)'=='UWP'">
-    <Import Project="pjsua_cli_shared_comp.vcxitems" Label="Shared" />
-  </ImportGroup>
+  <Import Project="pjsua_cli_shared_comp.vcxitems" Label="Shared" />  
   <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
     <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
@@ -271,6 +269,8 @@
       <OutputFile>..\lib\pjsua-cli-uwp-comp-$(TargetCPU)-$(Platform)-vc$(VSVer)-$(Configuration).dll</OutputFile>
     </Link>
-  </ItemDefinitionGroup>
-  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  </ItemDefinitionGroup>  
+  <!--Don't build this project unless it's for UWP-->
+  <Import Condition="'$(API_Family)'=='UWP'" Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <Import Condition="'$(API_Family)'!='UWP'" Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-build-targets.targets" />      
   <ImportGroup Label="ExtensionTargets">
   </ImportGroup>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_wp8_comp.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_wp8_comp.vcxproj	(revision 5527)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_wp8_comp.vcxproj	(revision 5528)
@@ -52,5 +52,5 @@
   <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
-  <ImportGroup Condition="'$(API_Family)'=='WinPhone8'">
+  <ImportGroup>
     <Import Project="pjsua_cli_shared_comp.vcxitems" Label="Shared" />
   </ImportGroup>
@@ -158,6 +158,8 @@
     </ProjectReference>
   </ItemGroup>
-  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
-  <Import Project="$(MSBuildExtensionsPath)\Microsoft\WindowsPhone\v$(TargetPlatformVersion)\Microsoft.Cpp.WindowsPhone.$(TargetPlatformVersion).targets" />
+  <!--Don't build this project unless it's for WinPhone8-->
+  <Import Condition="'$(API_Family)'=='WinPhone8'" Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <Import Condition="'$(API_Family)'=='WinPhone8'" Project="$(MSBuildExtensionsPath)\Microsoft\WindowsPhone\v$(TargetPlatformVersion)\Microsoft.Cpp.WindowsPhone.$(TargetPlatformVersion).targets" />
+  <Import Condition="'$(API_Family)'!='WinPhone8'" Project="..\..\..\..\..\..\build\vs\pjproject-vs14-build-targets.targets" />
   <ImportGroup Label="ExtensionTargets">
   </ImportGroup>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Voip.csproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Voip.csproj	(revision 5527)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Voip.csproj	(revision 5528)
@@ -1,6 +1,11 @@
 ﻿<?xml version="1.0" encoding="utf-8"?>
-<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+<Project ToolsVersion="14.0" DefaultTargets="CheckAPI" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <!--Check for API_Family-->
+  <PropertyGroup>
+      <PROJ_Target>UWP</PROJ_Target>
+  </PropertyGroup>
   <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
+  <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-targets.targets" />
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj	(revision 5527)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj	(revision 5528)
@@ -271,5 +271,7 @@
     <ClInclude Include="MyApp.h" />
   </ItemGroup>
-  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <!--Don't build this project unless it's for UWP-->
+  <Import Condition="'$(API_Family)'=='UWP'" Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <Import Condition="'$(API_Family)'!='UWP'" Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-build-targets.targets" />
   <ImportGroup Label="ExtensionTargets">
   </ImportGroup>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj	(revision 5527)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj	(revision 5528)
@@ -240,5 +240,7 @@
     </Link>
   </ItemDefinitionGroup>
-  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <!--Don't build this project unless it's for UWP-->
+  <Import Condition="'$(API_Family)'=='UWP'" Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <Import Condition="'$(API_Family)'!='UWP'" Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-build-targets.targets" />
   <ImportGroup Label="ExtensionTargets">
   </ImportGroup>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/VoipTasks.csproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/VoipTasks.csproj	(revision 5527)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/VoipTasks.csproj	(revision 5528)
@@ -1,6 +1,11 @@
 ﻿<?xml version="1.0" encoding="utf-8"?>
-<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+<Project ToolsVersion="14.0" DefaultTargets="CheckAPI" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <!--Check for API_Family-->
+  <PropertyGroup>
+      <PROJ_Target>UWP</PROJ_Target>
+  </PropertyGroup>    
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />    
   <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
+  <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-targets.targets" />
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>