Index: pjproject/branches/projects/uwp/pjproject-vs14.sln
===================================================================
--- pjproject/branches/projects/uwp/pjproject-vs14.sln	(revision 5526)
+++ pjproject/branches/projects/uwp/pjproject-vs14.sln	(revision 5529)
@@ -99,14 +99,4 @@
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "pjsua_winrt_gui", "pjsua_winrt_gui", "{78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}"
 EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "wp8", "wp8", "{DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Agents", "pjsip-apps\src\pjsua\winrt\gui\wp8\Agents\Agents.csproj", "{820034C1-645D-4340-8813-D980C1EF77DE}"
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "BackEnd", "pjsip-apps\src\pjsua\winrt\gui\wp8\BackEnd\BackEnd.vcxproj", "{C8D75245-FFCF-4932-A228-C9CC8BB60B03}"
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "BackEndProxyStub", "pjsip-apps\src\pjsua\winrt\gui\wp8\BackEndProxyStub\BackEndProxyStub.vcxproj", "{BBABEEA1-494C-4618-96E3-399873A5558B}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "UI", "pjsip-apps\src\pjsua\winrt\gui\wp8\UI\UI.csproj", "{3085ACA0-00DA-45BF-9110-A3684B56EBBA}"
-EndProject
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "uwp", "uwp", "{87D83489-039E-4123-BE01-CB62EE932A29}"
 EndProject
@@ -127,4 +117,5 @@
 		pjsip-apps\src\pjsua\winrt\cli\comp\pjsua_cli_shared_comp.vcxitems*{207e7bd4-7b11-4a40-ba3a-cc627762a7b6}*SharedItemsImports = 4
 		pjsip-apps\src\pjsua\winrt\cli\comp\pjsua_cli_shared_comp.vcxitems*{45d41acc-2c3c-43d2-bc10-02aa73ffc7c7}*SharedItemsImports = 9
+		pjsip-apps\src\pjsua\winrt\cli\comp\pjsua_cli_shared_comp.vcxitems*{e75efd41-c7f5-44c8-8ff1-a310d920989d}*SharedItemsImports = 4
 	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
@@ -1629,212 +1620,4 @@
 		{E75EFD41-C7F5-44C8-8FF1-A310D920989D}.Release-Static|x64.ActiveCfg = Release|ARM
 		{E75EFD41-C7F5-44C8-8FF1-A310D920989D}.Release-Static|x64.Build.0 = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|ARM.ActiveCfg = Debug|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|ARM.Build.0 = Debug|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|Win32.ActiveCfg = Debug|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|Win32.Build.0 = Debug|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|x64.ActiveCfg = Debug|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug|x64.Build.0 = Debug|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|Any CPU.ActiveCfg = Debug|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|Any CPU.Build.0 = Debug|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|ARM.ActiveCfg = Debug|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|ARM.Build.0 = Debug|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|Win32.ActiveCfg = Debug|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|Win32.Build.0 = Debug|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|x64.ActiveCfg = Debug|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Dynamic|x64.Build.0 = Debug|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|Any CPU.ActiveCfg = Debug|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|Any CPU.Build.0 = Debug|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|ARM.ActiveCfg = Debug|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|ARM.Build.0 = Debug|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|Win32.ActiveCfg = Debug|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|Win32.Build.0 = Debug|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|x64.ActiveCfg = Debug|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Debug-Static|x64.Build.0 = Debug|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|Any CPU.Build.0 = Release|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|ARM.ActiveCfg = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|ARM.Build.0 = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|Win32.ActiveCfg = Release|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|Win32.Build.0 = Release|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|x64.ActiveCfg = Release|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release|x64.Build.0 = Release|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|Any CPU.ActiveCfg = Release|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|Any CPU.Build.0 = Release|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|ARM.ActiveCfg = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|ARM.Build.0 = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|Win32.ActiveCfg = Release|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|Win32.Build.0 = Release|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|x64.ActiveCfg = Release|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Dynamic|x64.Build.0 = Release|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|Any CPU.ActiveCfg = Release|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|Any CPU.Build.0 = Release|Any CPU
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|ARM.ActiveCfg = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|ARM.Build.0 = Release|ARM
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|Win32.ActiveCfg = Release|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|Win32.Build.0 = Release|Win32
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|x64.ActiveCfg = Release|x64
-		{820034C1-645D-4340-8813-D980C1EF77DE}.Release-Static|x64.Build.0 = Release|x64
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug|Any CPU.ActiveCfg = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug|ARM.ActiveCfg = Debug|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug|ARM.Build.0 = Debug|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug|Win32.ActiveCfg = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug|Win32.Build.0 = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug|x64.ActiveCfg = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|Any CPU.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|Any CPU.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|ARM.ActiveCfg = Debug|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|ARM.Build.0 = Debug|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|Win32.ActiveCfg = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|Win32.Build.0 = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|x64.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Dynamic|x64.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|Any CPU.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|Any CPU.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|ARM.ActiveCfg = Debug|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|ARM.Build.0 = Debug|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|Win32.ActiveCfg = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|Win32.Build.0 = Debug|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|x64.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Debug-Static|x64.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release|Any CPU.ActiveCfg = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release|ARM.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release|ARM.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release|Win32.ActiveCfg = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release|Win32.Build.0 = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release|x64.ActiveCfg = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|Any CPU.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|Any CPU.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|ARM.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|ARM.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|Win32.ActiveCfg = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|Win32.Build.0 = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|x64.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Dynamic|x64.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|Any CPU.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|Any CPU.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|ARM.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|ARM.Build.0 = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|Win32.ActiveCfg = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|Win32.Build.0 = Release|Win32
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|x64.ActiveCfg = Release|ARM
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03}.Release-Static|x64.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug|Any CPU.ActiveCfg = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug|ARM.ActiveCfg = Debug|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug|ARM.Build.0 = Debug|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug|Win32.ActiveCfg = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug|Win32.Build.0 = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug|x64.ActiveCfg = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|Any CPU.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|Any CPU.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|ARM.ActiveCfg = Debug|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|ARM.Build.0 = Debug|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|Win32.ActiveCfg = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|Win32.Build.0 = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|x64.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Dynamic|x64.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|Any CPU.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|Any CPU.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|ARM.ActiveCfg = Debug|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|ARM.Build.0 = Debug|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|Win32.ActiveCfg = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|Win32.Build.0 = Debug|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|x64.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Debug-Static|x64.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release|Any CPU.ActiveCfg = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release|ARM.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release|ARM.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release|Win32.ActiveCfg = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release|Win32.Build.0 = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release|x64.ActiveCfg = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|Any CPU.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|Any CPU.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|ARM.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|ARM.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|Win32.ActiveCfg = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|Win32.Build.0 = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|x64.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Dynamic|x64.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|Any CPU.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|Any CPU.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|ARM.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|ARM.Build.0 = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|Win32.ActiveCfg = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|Win32.Build.0 = Release|Win32
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|x64.ActiveCfg = Release|ARM
-		{BBABEEA1-494C-4618-96E3-399873A5558B}.Release-Static|x64.Build.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|Any CPU.Deploy.0 = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|ARM.ActiveCfg = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|ARM.Build.0 = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|ARM.Deploy.0 = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|Win32.ActiveCfg = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|Win32.Build.0 = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|Win32.Deploy.0 = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|x64.ActiveCfg = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|x64.Build.0 = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug|x64.Deploy.0 = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|Any CPU.ActiveCfg = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|Any CPU.Build.0 = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|Any CPU.Deploy.0 = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|ARM.ActiveCfg = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|ARM.Build.0 = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|ARM.Deploy.0 = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|Win32.ActiveCfg = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|Win32.Build.0 = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|Win32.Deploy.0 = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|x64.ActiveCfg = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|x64.Build.0 = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Dynamic|x64.Deploy.0 = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|Any CPU.ActiveCfg = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|Any CPU.Build.0 = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|Any CPU.Deploy.0 = Debug|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|ARM.ActiveCfg = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|ARM.Build.0 = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|ARM.Deploy.0 = Debug|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|Win32.ActiveCfg = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|Win32.Build.0 = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|Win32.Deploy.0 = Debug|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|x64.ActiveCfg = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|x64.Build.0 = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Debug-Static|x64.Deploy.0 = Debug|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|Any CPU.Build.0 = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|Any CPU.Deploy.0 = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|ARM.ActiveCfg = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|ARM.Build.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|ARM.Deploy.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|Win32.ActiveCfg = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|Win32.Build.0 = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|Win32.Deploy.0 = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|x64.ActiveCfg = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|x64.Build.0 = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release|x64.Deploy.0 = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|Any CPU.ActiveCfg = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|Any CPU.Build.0 = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|Any CPU.Deploy.0 = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|ARM.ActiveCfg = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|ARM.Build.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|ARM.Deploy.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|Win32.ActiveCfg = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|Win32.Build.0 = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|Win32.Deploy.0 = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|x64.ActiveCfg = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|x64.Build.0 = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Dynamic|x64.Deploy.0 = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|Any CPU.ActiveCfg = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|Any CPU.Build.0 = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|Any CPU.Deploy.0 = Release|Any CPU
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|ARM.ActiveCfg = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|ARM.Build.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|ARM.Deploy.0 = Release|ARM
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|Win32.ActiveCfg = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|Win32.Build.0 = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|Win32.Deploy.0 = Release|Win32
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|x64.ActiveCfg = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|x64.Build.0 = Release|x64
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA}.Release-Static|x64.Deploy.0 = Release|x64
 		{B11B5672-B1E8-4C77-BDA1-4E6620F96BF9}.Debug|Any CPU.ActiveCfg = Debug|x86
 		{B11B5672-B1E8-4C77-BDA1-4E6620F96BF9}.Debug|ARM.ActiveCfg = Debug|ARM
@@ -2147,9 +1930,4 @@
 		{207E7BD4-7B11-4A40-BA3A-CC627762A7B6} = {54F6163A-66C6-4F09-844D-CC61DE8EE376}
 		{E75EFD41-C7F5-44C8-8FF1-A310D920989D} = {54F6163A-66C6-4F09-844D-CC61DE8EE376}
-		{DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F} = {78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}
-		{820034C1-645D-4340-8813-D980C1EF77DE} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
-		{C8D75245-FFCF-4932-A228-C9CC8BB60B03} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
-		{BBABEEA1-494C-4618-96E3-399873A5558B} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
-		{3085ACA0-00DA-45BF-9110-A3684B56EBBA} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
 		{87D83489-039E-4123-BE01-CB62EE932A29} = {78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}
 		{B11B5672-B1E8-4C77-BDA1-4E6620F96BF9} = {87D83489-039E-4123-BE01-CB62EE932A29}